<!-- Nav -->
<%- include('partials/nav', {active: "images"}); %>

<div class="container-fluid">
    <div class="row d-flex d-md-block flex-nowrap wrapper">
        <main class="col-md-10 float-left col px-5 px-md-3 py-3 main">
            <h1 class="display-3 hidden-xs-down">
                Create a container
            </h1>
            <% include ./partials/messages %>
            <form action="/docker/container/create" method="POST" class="was-validated">

                <div class="form-group">
                    <label for="image" class="col-form-label"><%=image%></label>
                    <input type="hidden" id="image" name="image" value="<%=image%>">
                </div>
                <div class="form-group">
                    <label for="jobId" class="col-form-label"><%=jobId%></label>
                    <input type="hidden" id="jobId" name="jobId" value="<%=jobId%>">
                </div>
                <div class="form-group">
                    <% for (var i in envVariableList){%>
                        <div class="form-row mb-2">
                            <div class="col">
                                <% if (i==0) { %>
                                    <label for="envName<%=i%>">Environment Variable</label>
                                    <% } %>
                                        <input id="envName<%=i%>" type="text" class="form-control" placeholder="Name"
                                            name="envs[<%=i%>][name]" value="<%=envVariableList[i].name%>" <%-envVariableList[i].name.length > 0 ? 'readonly tabindex="-1"' : ''%> />
                            </div>

                            <div class="col">
                                <% if (i==0) { %>
                                <label for="envType<%=i%>">Type</label>
                                <% } %>
                                <select id="envType<%=i%>" class="form-control" name="envs[<%=i%>][type]" onchange="typeToggleHandler(this)" data-row-index="<%=i%>">
                                    <option value="" disabled>Select a type</option>
                                    <option value="manual" selected>Manual</option>
                                    <option value="vault">Vault</option>
                                </select>
                            </div>

                            <div class="col">
                                <% if (i==0) { %>
                                    <label>Value</label>
                                <% } %>
                                    <input id="envValue<%=i%>" type="<%=envVariableList[i].type%>" class="form-control" placeholder="Value"
                                        name="envs[<%=i%>][value]" <%-envVariableList[i].required ? 'required pattern="\\S(.*\\S)?"' : '' %> />
                        
                                    <!-- At least one non-whitespace character and no whitespace at the beginning or end of the input pattern="\S(.*\S)?" -->
                                    <!-- At least one non-whitespace character, but also allows whitespace characters (spaces, tabs, carriage returns, etc.) at the beginning or end pattern=".*\S+.*" -->
                        
                                    <select id="envPath<%=i%>" class="form-control" style="display: none;" name="envs[<%=i%>][path]" disabled
                                        <%-envVariableList[i].required ? 'required' : '' %>>
                                        <option value="" disabled selected>Select a path</option>
                                        <% for (var index in paths){%>
                                            <option value="<%=JSON.stringify(paths[index])%>">
                                                <%=`${paths[index].path}:${paths[index].key}`%>
                                            </option>
                                        <%} %>
                                    </select>
                            
                            </div>
                        </div>
                        <%} %>
                </div>
                <button type="submit" class="btn btn-primary">Create</button>
                <a class="btn btn-secondary" href="/dashboard/images">Back</a>
            </form>

        </main>
    </div>
</div>

<script>
    function typeToggleHandler(element) {
        console.log(element)
        if (element.value == 'manual') {
            document.getElementById(`envPath${element.dataset.rowIndex}`).style.display = 'none';
            document.getElementById(`envPath${element.dataset.rowIndex}`).disabled = true;
            document.getElementById(`envValue${element.dataset.rowIndex}`).style.display = 'block';
            document.getElementById(`envValue${element.dataset.rowIndex}`).disabled = false;
        }
        else {
            document.getElementById(`envPath${element.dataset.rowIndex}`).style.display = 'block';
            document.getElementById(`envPath${element.dataset.rowIndex}`).disabled = false;
            document.getElementById(`envValue${element.dataset.rowIndex}`).style.display = 'none';
            document.getElementById(`envValue${element.dataset.rowIndex}`).disabled = true;
        }
    }
</script>
